% Copyright Pieter Abbeel
%
% 3.2 Motion Model and Map
%
% My code runs in a fraction of a second.
%
% Load the map simple world and run the motion model again, this time
% starting from x0 as assigned in this file, and with the control inputs 
% provided in this file. Check for collisions, and illustrate effectiveness 
% by plotting the map and 5 generated trajectories in which states in collision 
% are plotted in green, states in open space are plotted in red.

% clear workspace, command window, close all images:
clear; clc; close all;


alpha = 0.1*ones(6,1);
delta_t = 0.1;
load simple_world
figure; axis equal; hold on; draw_gridworld(gridworld);

% 3 starting poses to run for:
s0{1} = [1.5; 2.5; 0];
s0{2} = [3.5; 3.5; pi];
s0{3} = [2.5; 8.0; -pi/4];

% control input sequence is same in all cases:
T = 20;
v = ones(1,T);
omega = zeros(1,T);
u = [v; omega];

for start_pose_idx = 1:length(s0)
	s = s0{start_pose_idx};
	for t=1:T-1
		s(:,t+1) = sample_motion_model_velocity(s(:,t), u(:,t), delta_t, alpha);%%YOU implemented this function for 3.1
		if(occupied(s(1,t+1),s(2,t+1), gridworld)) %% YOU need to implement the "occupied" check
			plot(s(1,t+1), s(2,t+1), 'g.');
		else
			plot(s(1,t+1), s(2,t+1), 'r.');
		end
	end
end

