% Copyright Pieter Abbeel
%
% 3.8 Likelihood Field
%
% tic; p3_8_likelihood_field; toc
% Elapsed time is 4.941105 seconds.
%
% construct the likelihood field for each of our three worlds and display
% it:

% clear workspace, command window, close all images:
clear; clc; close all;


%% construct the likelihood field (this is expensive pre-computation, hence
%% a bit expensive for only evaluating a small number of measurements, but of course we are
%% going to use this for many measurements very soon)
%
% I built the likelihood field at 4 times the resolution of the original
% gridmap
% I also found it best to have the likelihood field be based on distance to
% the nearest surface that could reflect a ray, rather than just the
% nearest obstacle; the problem with the latter being that it ends up
% preferring measurements at the inside of obstacles, which is not a good
% measurement model

lf_xy_res = [0.25; 0.25]; % we compute the likelihood field at discrete locations only, and then later use look-ups (with interpolation) to get readings at other points
p_hit = 0.95;
p_uniform = 0.05;
z_max = 20; 
sigma = 0.05; %YOU should vary this and look at the effect on the likelihood field

load simple_world
lf = likelihood_field_from_gridworld(gridworld, lf_xy_res, sigma, p_hit, p_uniform, z_max); %YOU need to implement this function
figure; axis equal; hold on; draw_likelihood_field(lf, lf_xy_res); 
%NOTE: this draws the likelihood field a bit "off" ; feel free to come up
%with a better drawing function; in particular it draws the likelihood
%field for, let's say (0.25, 0.25) into the entire square with corners:
%(0.25,0.25), (0.25, 0.50), (0.50, 0.50), (0.50, 0.25) --- i.e., the
%greyness of a square reflects the value at its bottom left corner


load rooms_world
lf = likelihood_field_from_gridworld(gridworld, lf_xy_res, sigma, p_hit, p_uniform, z_max); %YOURS
figure; axis equal; hold on; draw_likelihood_field(lf, lf_xy_res);

load loops_world_path0
lf = likelihood_field_from_gridworld(gridworld, lf_xy_res, sigma, p_hit, p_uniform, z_max); %YOURS
figure; axis equal; hold on; draw_likelihood_field(lf, lf_xy_res);






